Index: cards/delphes_card_CLICdet.tcl
===================================================================
--- cards/delphes_card_CLICdet.tcl	(revision d85c7c5805d79c11c5fd9eb16046bf6d51f6e2fa)
+++ cards/delphes_card_CLICdet.tcl	(revision ae061c180bb088537bf9c8ef359fadce58cf0b78)
@@ -30,5 +30,5 @@
     Calorimeter
     EFlowMerger
-    EFlowFilter
+
     
     PhotonEfficiency
@@ -44,4 +44,6 @@
     MuonIsolation
 
+    EFlowFilter
+    
     NeutrinoFilter
     GenJetFinder
@@ -88,5 +90,5 @@
     ScalarHT
 
-    UniqueObjectFinder
+
 
     TreeWriter
@@ -484,447 +486,5 @@
 }
 
-######################
-# EFlowFilter
-######################
-
-module PdgCodeFilter EFlowFilter {
-    set InputArray EFlowMerger/eflow
-    set OutputArray eflow
-    
-    add PdgCode {11}
-    add PdgCode {-11}
-    add PdgCode {13}
-    add PdgCode {-13}
-}
-
-
-###################
-# Missing ET merger
-###################
-
-module Merger MissingET {
-    # add InputArray InputArray
-    add InputArray EFlowMerger/eflow
-    set MomentumOutputArray momentum
-}
-
-
-##################
-# Scalar HT merger
-##################
-
-module Merger ScalarHT {
-    # add InputArray InputArray
-    add InputArray EFlowMerger/eflow
-    set EnergyOutputArray energy
-}
-
-#################
-# Neutrino Filter
-#################
-
-module PdgCodeFilter NeutrinoFilter {
-
-    set InputArray Delphes/stableParticles
-    set OutputArray filteredParticles
-
-    set PTMin 0.0
-
-    add PdgCode {12}
-    add PdgCode {14}
-    add PdgCode {16}
-    add PdgCode {-12}
-    add PdgCode {-14}
-    add PdgCode {-16}
-
-}
-
-
-#####################
-# MC truth jet finder
-#####################
-
-module FastJetFinder GenJetFinder {
-    set InputArray NeutrinoFilter/filteredParticles
-
-    set OutputArray jets
-
-    # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
-    set JetAlgorithm 9
-    set ParameterR 0.5
-
-    set JetPTMin 20.0
-}
-
-#########################
-# Gen Missing ET merger
-########################
-
-module Merger GenMissingET {
-    # add InputArray InputArray
-    add InputArray NeutrinoFilter/filteredParticles
-    set MomentumOutputArray momentum
-}
-
-
-
-############
-# Jet finder
-############
-
-module FastJetFinder FastJetFinderKt {
-    #  set InputArray Calorimeter/towers
-    set InputArray EFlowMerger/eflow
-
-    set OutputArray KTjets
-
-    # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
-    set JetAlgorithm 4
-    set ParameterR 0.5
-
-    set JetPTMin 20.0
-}
-
-############
-# Jet finder VLC
-############
-#R05 N2
-module FastJetFinder FastJetFinderVLC_R05_N2 {
-    #  set InputArray Calorimeter/towers
-    set InputArray EFlowMerger/eflow
-
-    set OutputArray VLCjetsR05N2
-
-    # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt, 7 anti-kt with winner-take-all axis (for N-subjettiness), 8 N-jettiness, 9 Valencia
-    set NJets 2
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 0.5
-    set Beta 1.0
-    set Gamma 1.0
-
-    set JetPTMin 20.0
-}
-#R05 N3
-module FastJetFinder FastJetFinderVLC_R05_N3 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR05N3
-    set NJets 3
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 0.5
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R05 N4
-module FastJetFinder FastJetFinderVLC_R05_N4 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR05N4
-    set NJets 4
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 0.5
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R05 N5
-module FastJetFinder FastJetFinderVLC_R05_N5 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR05N5
-    set NJets 5
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 0.5
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R05 N6
-module FastJetFinder FastJetFinderVLC_R05_N6 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR05N6
-    set NJets 6
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 0.5
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R07 N2
-module FastJetFinder FastJetFinderVLC_R07_N2 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR07N2
-    set NJets 2
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 0.7
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R07 N3
-module FastJetFinder FastJetFinderVLC_R07_N3 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR07N3
-    set NJets 3
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 0.7
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R07 N4
-module FastJetFinder FastJetFinderVLC_R07_N4 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR07N4
-    set NJets 4
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 0.7
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R07 N5
-module FastJetFinder FastJetFinderVLC_R07_N5 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR07N5
-    set NJets 5
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 0.7
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R07 N6
-module FastJetFinder FastJetFinderVLC_R07_N6 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR07N6
-    set NJets 6
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 0.7
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-
-#R10N2
-module FastJetFinder FastJetFinderVLC_R10_N2 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR10N2
-    set NJets 2
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 1.0
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R10 N3
-module FastJetFinder FastJetFinderVLC_R10_N3 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR10N3
-    set NJets 3
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 1.0
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R10 N4
-module FastJetFinder FastJetFinderVLC_R10_N4 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR10N4
-    set NJets 4
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 1.0
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R10 N5
-module FastJetFinder FastJetFinderVLC_R10_N5 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR10N5
-    set NJets 5
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 1.0
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R10 N6
-module FastJetFinder FastJetFinderVLC_R10_N6 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR10N6
-    set NJets 6
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 1.0
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-
-#R12 N2
-module FastJetFinder FastJetFinderVLC_R12_N2 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR12N2
-    set NJets 2
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 1.2
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R12 N3
-module FastJetFinder FastJetFinderVLC_R12_N3 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR12N3
-    set NJets 3
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 1.2
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R12 N4
-module FastJetFinder FastJetFinderVLC_R12_N4 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR12N4
-    set NJets 4
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 1.2
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R12 N5
-module FastJetFinder FastJetFinderVLC_R12_N5 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR12N5
-    set NJets 5
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 1.2
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R12 N6
-module FastJetFinder FastJetFinderVLC_R12_N6 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR12N6
-    set NJets 6
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 1.2
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-
-
-#R15 N2
-module FastJetFinder FastJetFinderVLC_R15_N2 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR15N2
-    set NJets 2
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 1.5
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R15 N3
-module FastJetFinder FastJetFinderVLC_R15_N3 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR15N3
-    set NJets 3
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 1.5
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R15 N4
-module FastJetFinder FastJetFinderVLC_R15_N4 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR15N4
-    set NJets 4
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 1.5
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R15 N5
-module FastJetFinder FastJetFinderVLC_R15_N5 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR15N5
-    set NJets 5
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 1.5
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-#R15 N6
-module FastJetFinder FastJetFinderVLC_R15_N6 {
-    set InputArray EFlowMerger/eflow
-    set OutputArray VLCjetsR15N6
-    set NJets 6
-    set ExclusiveClustering true
-    set JetAlgorithm 9
-    set ParameterR 1.5
-    set Beta 1.0
-    set Gamma 1.0
-    set JetPTMin 20.0
-}
-##################
-# Jet Energy Scale
-##################
-
-module EnergyScale JetEnergyScale {
-    set InputArray FastJetFinderKt/KTjets
-    set OutputArray jets
-
-    # scale formula for jets
-    set ScaleFormula {1.00}
-}
-
-
-########################
-# Jet Flavor Association
-########################
-
-module JetFlavorAssociation JetFlavorAssociation {
-
-    set PartonInputArray Delphes/partons
-    set ParticleInputArray Delphes/allParticles
-    set ParticleLHEFInputArray Delphes/allParticlesLHEF
-    set JetInputArray JetEnergyScale/jets
-
-    set DeltaR 0.5
-    set PartonPTMin 1.0
-    set PartonEtaMax 2.5
-
-}
+##here
 
 ###################
@@ -951,5 +511,5 @@
 module Isolation PhotonIsolation {
     set CandidateInputArray PhotonEfficiency/photons
-    set IsolationInputArray EFlowFilter/eflow
+    set IsolationInputArray EFlowMerger/eflow
 
     set OutputArray photons
@@ -985,5 +545,5 @@
 module Isolation ElectronIsolation {
     set CandidateInputArray ElectronEfficiency/electrons
-    set IsolationInputArray EFlowFilter/eflow
+    set IsolationInputArray EFlowMerger/eflow
 
     set OutputArray electrons
@@ -1021,5 +581,5 @@
 module Isolation MuonIsolation {
     set CandidateInputArray MuonEfficiency/muons
-    set IsolationInputArray EFlowFilter/eflow
+    set IsolationInputArray EFlowMerger/eflow
 
     set OutputArray muons
@@ -1030,4 +590,456 @@
 
     set PTRatioMax 0.25
+}
+
+
+
+###################
+# Missing ET merger
+###################
+
+module Merger MissingET {
+    # add InputArray InputArray
+    add InputArray EFlowMerger/eflow
+    set MomentumOutputArray momentum
+}
+
+
+##################
+# Scalar HT merger
+##################
+
+module Merger ScalarHT {
+    # add InputArray InputArray
+    add InputArray EFlowMerger/eflow
+    set EnergyOutputArray energy
+}
+######################
+# EFlowFilter (UniqueObjectFinder)
+######################
+module UniqueObjectFinder EFlowFilter {
+    add InputArray PhotonIsolation/photons photons
+    add InputArray ElectronIsolation/electrons electrons
+    add InputArray MuonIsolation/muons muons
+    add InputArray EFlowMerger/eflow eflow
+}
+
+
+#
+#module PdgCodeFilter EFlowFilter {
+#    set InputArray EFlowMerger/eflow
+#    set OutputArray eflow
+#    
+#    add PdgCode {11}
+#    add PdgCode {-11}
+#    add PdgCode {13}
+#    add PdgCode {-13}
+#}
+
+#################
+# Neutrino Filter
+#################
+
+module PdgCodeFilter NeutrinoFilter {
+
+    set InputArray Delphes/stableParticles
+    set OutputArray filteredParticles
+
+    set PTMin 0.0
+
+    add PdgCode {12}
+    add PdgCode {14}
+    add PdgCode {16}
+    add PdgCode {-12}
+    add PdgCode {-14}
+    add PdgCode {-16}
+
+}
+
+
+#####################
+# MC truth jet finder
+#####################
+
+module FastJetFinder GenJetFinder {
+    set InputArray NeutrinoFilter/filteredParticles
+
+    set OutputArray jets
+
+    # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
+    set JetAlgorithm 9
+    set ParameterR 0.5
+
+    set JetPTMin 20.0
+}
+
+#########################
+# Gen Missing ET merger
+########################
+
+module Merger GenMissingET {
+    # add InputArray InputArray
+    add InputArray NeutrinoFilter/filteredParticles
+    set MomentumOutputArray momentum
+}
+
+
+
+############
+# Jet finder
+############
+
+module FastJetFinder FastJetFinderKt {
+    #  set InputArray Calorimeter/towers
+    set InputArray EFlowMerger/eflow
+
+    set OutputArray KTjets
+
+    # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
+    set JetAlgorithm 4
+    set ParameterR 0.5
+
+    set JetPTMin 20.0
+}
+
+############
+# Jet finder VLC
+############
+#R05 N2
+module FastJetFinder FastJetFinderVLC_R05_N2 {
+    #  set InputArray Calorimeter/towers
+    set InputArray EFlowFilter/eflow
+
+    set OutputArray VLCjetsR05N2
+
+    # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt, 7 anti-kt with winner-take-all axis (for N-subjettiness), 8 N-jettiness, 9 Valencia
+    set NJets 2
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 0.5
+    set Beta 1.0
+    set Gamma 1.0
+
+    set JetPTMin 20.0
+}
+#R05 N3
+module FastJetFinder FastJetFinderVLC_R05_N3 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR05N3
+    set NJets 3
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 0.5
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R05 N4
+module FastJetFinder FastJetFinderVLC_R05_N4 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR05N4
+    set NJets 4
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 0.5
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R05 N5
+module FastJetFinder FastJetFinderVLC_R05_N5 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR05N5
+    set NJets 5
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 0.5
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R05 N6
+module FastJetFinder FastJetFinderVLC_R05_N6 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR05N6
+    set NJets 6
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 0.5
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R07 N2
+module FastJetFinder FastJetFinderVLC_R07_N2 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR07N2
+    set NJets 2
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 0.7
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R07 N3
+module FastJetFinder FastJetFinderVLC_R07_N3 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR07N3
+    set NJets 3
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 0.7
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R07 N4
+module FastJetFinder FastJetFinderVLC_R07_N4 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR07N4
+    set NJets 4
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 0.7
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R07 N5
+module FastJetFinder FastJetFinderVLC_R07_N5 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR07N5
+    set NJets 5
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 0.7
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R07 N6
+module FastJetFinder FastJetFinderVLC_R07_N6 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR07N6
+    set NJets 6
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 0.7
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+
+#R10N2
+module FastJetFinder FastJetFinderVLC_R10_N2 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR10N2
+    set NJets 2
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 1.0
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R10 N3
+module FastJetFinder FastJetFinderVLC_R10_N3 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR10N3
+    set NJets 3
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 1.0
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R10 N4
+module FastJetFinder FastJetFinderVLC_R10_N4 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR10N4
+    set NJets 4
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 1.0
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R10 N5
+module FastJetFinder FastJetFinderVLC_R10_N5 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR10N5
+    set NJets 5
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 1.0
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R10 N6
+module FastJetFinder FastJetFinderVLC_R10_N6 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR10N6
+    set NJets 6
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 1.0
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+
+#R12 N2
+module FastJetFinder FastJetFinderVLC_R12_N2 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR12N2
+    set NJets 2
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 1.2
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R12 N3
+module FastJetFinder FastJetFinderVLC_R12_N3 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR12N3
+    set NJets 3
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 1.2
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R12 N4
+module FastJetFinder FastJetFinderVLC_R12_N4 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR12N4
+    set NJets 4
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 1.2
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R12 N5
+module FastJetFinder FastJetFinderVLC_R12_N5 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR12N5
+    set NJets 5
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 1.2
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R12 N6
+module FastJetFinder FastJetFinderVLC_R12_N6 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR12N6
+    set NJets 6
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 1.2
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+
+
+#R15 N2
+module FastJetFinder FastJetFinderVLC_R15_N2 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR15N2
+    set NJets 2
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 1.5
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R15 N3
+module FastJetFinder FastJetFinderVLC_R15_N3 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR15N3
+    set NJets 3
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 1.5
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R15 N4
+module FastJetFinder FastJetFinderVLC_R15_N4 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR15N4
+    set NJets 4
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 1.5
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R15 N5
+module FastJetFinder FastJetFinderVLC_R15_N5 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR15N5
+    set NJets 5
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 1.5
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+#R15 N6
+module FastJetFinder FastJetFinderVLC_R15_N6 {
+    set InputArray EFlowFilter/eflow
+    set OutputArray VLCjetsR15N6
+    set NJets 6
+    set ExclusiveClustering true
+    set JetAlgorithm 9
+    set ParameterR 1.5
+    set Beta 1.0
+    set Gamma 1.0
+    set JetPTMin 20.0
+}
+##################
+# Jet Energy Scale
+##################
+
+module EnergyScale JetEnergyScale {
+    set InputArray FastJetFinderVLC_R10_N4/VLCjetsR10N4
+    set OutputArray jets
+
+    # scale formula for jets
+    set ScaleFormula {1.00}
+}
+
+
+########################
+# Jet Flavor Association
+########################
+
+module JetFlavorAssociation JetFlavorAssociation {
+
+    set PartonInputArray Delphes/partons
+    set ParticleInputArray Delphes/allParticles
+    set ParticleLHEFInputArray Delphes/allParticlesLHEF
+    set JetInputArray JetEnergyScale/jets
+
+    set DeltaR 0.5
+    set PartonPTMin 1.0
+    set PartonEtaMax 2.5
+
 }
 
@@ -1086,13 +1098,14 @@
 #####################################################
 
-module UniqueObjectFinder UniqueObjectFinder {
-    # earlier arrays take precedence over later ones
-    # add InputArray InputArray OutputArray
-    add InputArray PhotonIsolation/photons photons
-    add InputArray ElectronIsolation/electrons electrons
-    add InputArray MuonIsolation/muons muons
-    add InputArray JetEnergyScale/jets jets
-}
-
+#module UniqueObjectFinder UniqueObjectFinder {
+#    # earlier arrays take precedence over later ones
+#    # add InputArray InputArray OutputArray
+#    add InputArray PhotonIsolation/photons photons
+#    add InputArray ElectronIsolation/electrons electrons
+#    add InputArray MuonIsolation/muons muons
+#    add InputArray JetEnergyScale/jets jets
+####not necessary any more, since these objects have already been removed if necessary??
+#}
+#
 
 ##################
@@ -1147,8 +1160,19 @@
     add Branch HCal/eflowNeutralHadrons EFlowNeutralHadron Tower
     
-    add Branch UniqueObjectFinder/photons Photon Photon
-    add Branch UniqueObjectFinder/electrons Electron Electron
-    add Branch UniqueObjectFinder/muons Muon Muon
-    add Branch UniqueObjectFinder/jets Jet Jet
+#    add Branch UniqueObjectFinder/photons Photon Photon
+#    add Branch UniqueObjectFinder/electrons Electron Electron
+#    add Branch UniqueObjectFinder/muons Muon Muon
+#    add Branch UniqueObjectFinder/jets Jet Jet
+#    
+
+#    add Branch PhotonIsolation/photons Photon Photon
+#    add Branch ElectronIsolation/electrons Electron Electron
+#    add Branch MuonIsolation/muons Muon Muon
+
+    add Branch EFlowFilter/photons Photon Photon
+    add Branch EFlowFilter/electrons Electron Electron
+    add Branch EFlowFilter/muons Muon Muon
+    
+        
     
     add Branch MissingET/momentum MissingET MissingET
